﻿namespace Čtvrtý
{
    public abstract class GrafickýObjekt: ICloneable
    {
        public int Barva { get; set; }
        public GrafickýObjekt(int barva) => Barva = barva;
        //public abstract void Nakresli();
        public virtual void Nakresli()
        {
            Console.Write("["+ Barva + "]");
        }

        public virtual object Clone()
        {
            return MemberwiseClone();
        }

        public void met() { }
    }

    public sealed class Bod : GrafickýObjekt
    {
        public int X { get; set; }
        public int Y { get; set; }
        public Bod(int barva, int x, int y):base(barva) { X = x; Y = y; }
        public override void Nakresli()
        {
            //Console.Write("[" + Barva + "](" + X + ", " + Y + ")");
            base.Nakresli();
            Console.Write("(" + X + ", " + Y + ")");
        }

    }

    public class Úsečka: GrafickýObjekt
    {
        public Bod Počátek { get;set; }
        public Bod Konec { get; set; }
        public Úsečka(int barva, Bod počátek, Bod konec):base(barva)
        {
            Počátek = (Bod)počátek.Clone(); 
            Konec = (Bod)konec.Clone();
        }
        public override void Nakresli()
        {
            base.Nakresli();
            Počátek.Nakresli();
            Konec.Nakresli();
        }

        public override object Clone()
        {
            var výsledek = (Úsečka) base.Clone();
            výsledek.Počátek = (Bod)Počátek.Clone();
            výsledek.Konec = (Bod)Konec.Clone();
            return výsledek;
        }
    }

    public class Obrázek: GrafickýObjekt
    {
        private List<GrafickýObjekt> obrázek = new();

        public Obrázek() : base(0)
        {
        }
        public void Přidej(GrafickýObjekt g)
        {
            obrázek.Add((GrafickýObjekt)g.Clone());
        }
    }

    
    internal class Program
    {
        private static void Main(string[] args)
        {
            GrafickýObjekt go = new Bod(9, 8, 6);
            //go = GrafickýObjekt(9);
            go.Nakresli();
            GrafickýObjekt go1 = (GrafickýObjekt)go.Clone();
            ((Bod)go1).X = 99;
            go1.Nakresli();
            go.Nakresli();
            go = new Úsečka(9, new Bod(9, 8, 6), new Bod(6,4,5));
        }
    }
}